using System.Linq;

namespace Logic
{
  /// <summary>
  /// a binary operator that represent a function of the truth values of two propositions
  /// </summary>
  internal abstract class BinaryOperator : Matrix
	{
	  private Matrix mLeft;
		private Matrix mRight;
		
		protected Matrix Left
		{
		  get { return mLeft; }
		}
		
		protected Matrix Right
		{
		  get { return mRight; }
		}
    
    protected abstract string Connector
    {
      get;
    }
    
    internal BinaryOperator( Matrix aLeft, Matrix aRight )
		{
		  this.mLeft = aLeft;
		  this.mRight = aRight;
		}
    
    public override string ToString()
    {
      return string.Format( "({0}){1}({2})", Left, Connector, Right );
    }
    
    internal override System.Collections.Generic.IEnumerable<Predicate> FindPredicates()
    {
      return Left.FindPredicates().Union( Right.FindPredicates() );
    }
	}
}

