namespace Logic
{
  /// <summary>
  /// a logical conjunction
  /// </summary>
  internal class Conjunction : BinaryOperator
  {
    internal Conjunction( Matrix aLeft, Matrix aRight ) : base( aLeft, aRight )
    {
    }
    
    internal override bool TrueForUniverse( uint aPossibleUniverse, Predicates aPredicates )
    {
      return Left.TrueForUniverse( aPossibleUniverse, aPredicates ) && Right.TrueForUniverse( aPossibleUniverse, aPredicates );
    }
    
    protected override string Connector
    {
      get { return "&"; }
    }
  }
}
