namespace Logic
{
  /// <summary>
  /// a logical disjunction
  /// </summary>
  internal class Disjunction : BinaryOperator
  {
    protected override string Connector
    {
      get { return "|"; }
    }

    internal Disjunction( Matrix aLeft, Matrix aRight ) : base( aLeft, aRight )
    {
    }
      
    internal override bool TrueForUniverse( uint aPossibleUniverse, Predicates aPredicates )
    {
      return Left.TrueForUniverse( aPossibleUniverse, aPredicates ) || Right.TrueForUniverse( aPossibleUniverse, aPredicates );
    }
  }
}
