namespace Logic
{
  /// <summary>
  /// a logical equivalence
  /// </summary>
  internal class Equivalence : BinaryOperator
  {
    protected override string Connector
    {
      get { return "<=>"; }
    }

    internal Equivalence( Matrix aLeft, Matrix aRight ) : base( aLeft, aRight )
    {
    }
    
    internal override bool TrueForUniverse( uint aPossibleUniverse, Predicates aPredicates )
    {
      return Left.TrueForUniverse( aPossibleUniverse, aPredicates ) == Right.TrueForUniverse( aPossibleUniverse, aPredicates );
    }
  }
}
