namespace Logic
{
  /// <summary>
  /// a joint denial
  /// </summary>
	internal class JointDenial : BinaryOperator
	{
	  protected override string Connector
    {
      get { return "!"; }
    }
	  
	  internal JointDenial( Matrix aLeft, Matrix aRight ) : base( aLeft, aRight )
	  {
		}
		
		internal override bool TrueForUniverse( uint aPossibleUniverse, Predicates aPredicates )
		{
		  return !Left.TrueForUniverse( aPossibleUniverse, aPredicates ) && !Right.TrueForUniverse( aPossibleUniverse, aPredicates );
		}
	}
}
