namespace Logic
{
  /// <summary>
  /// a material conditional
  /// </summary>
  internal class MaterialConditional : BinaryOperator
  {
    protected override string Connector
    {
      get { return "->"; }
    }

    internal MaterialConditional( Matrix aLeft, Matrix aRight ) : base( aLeft, aRight )
    {
    }
    
    internal override bool TrueForUniverse( uint aPossibleUniverse, Predicates aPredicates )
    {
      return !Left.TrueForUniverse( aPossibleUniverse, aPredicates ) || Right.TrueForUniverse( aPossibleUniverse, aPredicates );
    }
  }
}
