using System.Collections.Generic;
using System.Linq;

namespace Logic
{
	public abstract class Matrix
	{
		internal Matrix()
		{
		}
		
		internal abstract IEnumerable<Predicate> FindPredicates();
		
		internal Predicates BuildPredicateDictionary()
		{
		  return new Predicates( FindPredicates() );
		}
		
		internal abstract bool TrueForUniverse( uint aPossibleUniverse, Predicates aPredicateDictionary );
		
		public bool TrueInMaximallyDiverseUniverse
		{
		  get { return TrueForUniverse( 0xFFFFFFFF, new Predicates( Enumerable.Empty<Predicate>() ) ); }
		}
	}
}
