﻿using System.Linq;

namespace Logic
{
  /// <summary>
  /// a logical necessity; true if the matrix is true in all possible universes, false otherwise
  /// </summary>
  internal class Necessity : UnaryOperator
  {
    internal Necessity( Matrix aMatrix )
      : base( aMatrix )
    {
    }
    
    internal override bool TrueForUniverse( uint aPossibleUniverse, Predicates aPredicates )
    {
      Predicates lPredicateDictionary = BuildPredicateDictionary();
      
      return lPredicateDictionary.PossibleUniverses
        .All( fUniverse => mInnerProposition.TrueForUniverse( fUniverse, lPredicateDictionary ) );
    }
	  
	  public override string ToString()
	  {
	    return string.Format( "[]{0}", mInnerProposition );
	  }
  }
}
