namespace Logic
{
  /// <summary>
  /// a predicate over one variable
  /// </summary>
  public class Predicate
  {
    private string mDescription;
    
    internal Predicate( string aDescription )
    {
      mDescription = aDescription;
    }
    
    public override string ToString()
    {
      return mDescription;
    }
    
    public override bool Equals( object obj )
    {
      if ( obj is Predicate )
      {
        Predicate that = obj as Predicate;
        
        return this.ToString() == that.ToString();
      }
      
      throw new EngineException( "Predicate compared to non-Predicate." );
    }
    
    public override int GetHashCode()
    {
      return ToString().GetHashCode();
    }
  }
}
