using System.Collections.Generic;

namespace Logic
{
  /// <summary>
  /// a predication on one variable
  /// </summary>
  internal class Predication : Matrix
  {
    private Variable mVariable;
    private Predicate mPredicate;
    
    internal Predication( Predicate aPredicate, Variable aVariable )
    {
      mPredicate = aPredicate;
      mVariable = aVariable;
    }
    
    internal override bool TrueForUniverse( uint aPossibleUniverse, Predicates aPredicates )
    {
      return mVariable.CurrentlyInstantiatedPredicateCombination.IndexOf( mPredicate.ToString() ) >= 0;
    }
    
    public override string ToString()
    {
      return string.Format( "{0}{1}", mPredicate, mVariable );
    }
    
    internal override IEnumerable<Predicate> FindPredicates()
    {
      yield return mPredicate;
    }
  }
}
