using System;
using System.Collections.Generic;
using System.Linq;

namespace Logic
{
	public abstract class Proposition
	{
		internal Proposition()
		{
		}
		
		internal abstract IEnumerable<Predicate> FindPredicates();
		
		internal PredicateDictionary BuildPredicateDictionary()
		{
		  return new PredicateDictionary( FindPredicates() );
		}
		
		internal abstract bool TrueForUniverse( uint possibleUniverse, PredicateDictionary aPredicateDictionary );
		
		public bool TrueInMaximallyDiverseUniverse
		{
		  get { return TrueForUniverse( 0xFFFFFFFF, new PredicateDictionary( Enumerable.Empty<Predicate>() ) ); }
		}
	}
}
