﻿using System.Collections.Generic;
using System.Linq;

namespace Logic
{
  /// <summary>
  /// Utility methods
  /// </summary>
  public static class Utility
  {
    public static bool IsOneOf<T>( this T aItem, params T[] aItems )
    {
      return aItems.Any( fItem => fItem.Equals( aItem ) );
    }
    
    public static T[] MakeArray<T>( params T[] aItems )
    {
      return aItems;
    }
    
    public static bool Intersects<T>( this IEnumerable<T> aSet1, IEnumerable<T> aSet2 )
    {
      return aSet1.Intersect( aSet2 ).Count() > 0;
    }
    
    public static IEnumerable<T> Tail<T>( this IEnumerable<T> aEnumerable )
    {
      return aEnumerable.Skip( 1 );
    }
    
    public static T Head<T>( this IEnumerable<T> aEnumerable )
    {
      return aEnumerable.First();
    }
  }
}
