﻿using System.Collections.Generic;

namespace Logic
{
  internal class PredicateDictionary
  {
    private Dictionary<char, Predicate> mPredicates;

    public PredicateDictionary()
    {
      mPredicates = new Dictionary<char, Predicate>();
    }

    public Predicate Add( char aSymbol )
    {
      if ( mPredicates.ContainsKey( aSymbol ) )
      {
        return mPredicates[ aSymbol ];
      }
      else
      {
        Predicate aPredicate = Factory.Predicate( aSymbol.ToString() );

        mPredicates.Add( aSymbol, aPredicate );

        return aPredicate;
      }
    }

    public Predicate Retrieve( char aSymbol )
    {
      return mPredicates[ aSymbol ];
    }
  }
}
