﻿using System.Collections.Generic;

namespace Logic
{
  internal class VariableDictionary
  {
    internal Dictionary<char, Variable> mVariables;

    public VariableDictionary()
    {
      mVariables = new Dictionary<char, Variable>();
    }

    protected void Add( char aSymbol, Variable aVariable )
    {
      mVariables.Add( aSymbol, aVariable );
    }

    public VariableDictionary UpdateWith( char aSymbol, Variable aVariable )
    {
      VariableDictionary lUpdatedDictionary = new VariableDictionary();

      foreach ( char lSymbol in mVariables.Keys )
      {
        if ( lSymbol != aSymbol )
          lUpdatedDictionary.Add( lSymbol, mVariables[ lSymbol ] );
      }

      lUpdatedDictionary.Add( aSymbol, aVariable );

      return lUpdatedDictionary;
    }

    public Variable Retrieve( char aSymbol )
    {
      try
      {
        return mVariables[ aSymbol ];
      }
      catch ( KeyNotFoundException )
      {
        throw new FreeVariableNotFoundException( aSymbol );
      }
    }
  }
}
